clear
clear mata
clear matrix
set mem 5g
set more 1


* input your directory here.
* cd 

clear
gen x=.
save "../output/betas_total_CV", replace

use "../source/CRSP_monthly_79_14.dta", clear
gen year=year(date)
gen month=month(date)
	***cf cohen, polk and voltuehano
	replace ret=-.5 if ret<-.5
	replace ret=1 if ret>1&ret~=.
	gen date2=year(date)*100+month(date)
	ren date date3
	ren date2 date
	ren date3 date2
	sort date

sort year month
merge m:1 year month using ../output/news


drop if _m==2
drop _m


	sort date
	merge m:1 date using "../source/rf"
	drop if _m==2
	drop _m
	replace rf=rf/100
	gen ret_rf=ret-rf
	
	egen D=group(date)
	cap drop beta_DR
	gen beta_DR=.
	cap drop beta_CF
	gen beta_CF=.


	
	
levelsof D, local(levels)
    foreach i of local levels{
	disp `i'
	preserve
	quietly keep if D>=`i'&D<`i'+24
	quietly cap drop x1
	quietly egen x1=mean(ret) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly cap drop x2
	quietly egen x2=mean(ncf) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly  cap drop xy
	quietly  gen xy=(ret-x1)*(ncf-x2)  if ret~=.&ncf~=.&nr~=.
	cap drop x3
	quietly egen x3=mean(ncf-nr) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly  cap drop X2
	quietly  gen X2=(ncf-nr-x3)^2 if ret~=.&ncf~=.&nr~=.
	quietly  cap drop S1
	quietly  egen S1=sum(xy),by(permno)
	quietly  cap drop S2
	quietly  egen S2=sum(X2),by(permno)
	quietly  cap drop N1
	quietly  egen N1=count(xy),by(permno)
	quietly  cap drop N2
	quietly  egen N2=count(X2),by(permno)
	quietly cap drop temp1
	quietly  gen temp1=S1/S2 if D==`i'+23&N1>=12&N2>=12
	
	quietly cap drop x1
	quietly egen x1=mean(ret) if ret~=.&ncf_1~=.&nr~=.&ncf~=.,by(permno)
	quietly cap drop x2
	quietly egen x2=mean(ncf_1) if ret~=.&ncf_1~=.&nr~=.&ncf~=.,by(permno)
	quietly  cap drop xy
	quietly  gen xy=(ret-x1)*(ncf_1-x2)  if ret~=.&ncf_1~=.&nr~=.&ncf~=.
	cap drop x3
	quietly egen x3=mean(ncf-nr) if ret~=.&ncf_1~=.&nr~=.&ncf~=.,by(permno)
	quietly  cap drop X2
	quietly  gen X2=(ncf-nr-x3)^2  if ret~=.&ncf_1~=.&nr~=.&ncf~=.
	quietly  cap drop S1
	quietly  egen S1=sum(xy),by(permno)
	quietly  cap drop S2
	quietly  egen S2=sum(X2),by(permno)
	quietly  cap drop N1
	quietly  egen N1=count(xy),by(permno)
	quietly  cap drop N2
	quietly  egen N2=count(X2),by(permno)
	quietly cap drop temp2
	quietly  gen temp2=S1/S2 if D==`i'+23&N1>=12&N2>=12
	replace beta_CF=temp1+temp2	
	
	quietly cap drop x1
	quietly egen x1=mean(ret) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly cap drop x2
	quietly egen x2=mean(nr) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly  cap drop xy
	quietly  gen xy=(ret-x1)*(nr-x2)  if ret~=.&ncf~=.&nr~=.
	cap drop x3
	quietly egen x3=mean(ncf-nr) if ret~=.&ncf~=.&nr~=.,by(permno)
	quietly  cap drop X2
	quietly  gen X2=(ncf-nr-x3)^2 if ret~=.&ncf~=.&nr~=.
	quietly  cap drop S1
	quietly  egen S1=sum(xy),by(permno)
	quietly  cap drop S2
	quietly  egen S2=sum(X2),by(permno)
	quietly  cap drop N1
	quietly  egen N1=count(xy),by(permno)
	quietly  cap drop N2
	quietly  egen N2=count(X2),by(permno)
	quietly cap drop temp1
	quietly  gen temp1=S1/S2 if D==`i'+23&N1>=12&N2>=12
	
	quietly cap drop x1
	quietly egen x1=mean(ret) if ret~=.&nr_1~=.&nr~=.&ncf~=.,by(permno)
	quietly cap drop x2
	quietly egen x2=mean(nr_1) if ret~=.&nr_1~=.&nr~=.&ncf~=.,by(permno)
	quietly  cap drop xy
	quietly  gen xy=(ret-x1)*(nr_1-x2)  if ret~=.&nr_1~=.&nr~=.&ncf~=.
	cap drop x3
	quietly egen x3=mean(ncf-nr) if ret~=.&nr_1~=.&nr~=.&ncf~=.,by(permno)
	quietly  cap drop X2
	quietly  gen X2=(ncf-nr-x3)^2  if ret~=.&nr_1~=.&nr~=.&ncf~=.
	quietly  cap drop S1
	quietly  egen S1=sum(xy),by(permno)
	quietly  cap drop S2
	quietly  egen S2=sum(X2),by(permno)
	quietly  cap drop N1
	quietly  egen N1=count(xy),by(permno)
	quietly  cap drop N2
	quietly  egen N2=count(X2),by(permno)
	quietly cap drop temp2
	quietly  gen temp2=S1/S2 if D==`i'+23&N1>=12&N2>=12
	replace beta_DR=temp1+temp2	
	
	quietly  keep if D==`i'+23
	quietly  keep permno date date2 beta_DR beta_CF N1 N2
	quietly  append using "../output/betas_total_CV"
	quietly  save "../output/betas_total_CV", replace
	restore
	}
	
	
	use "../output/betas_total_CV", replace
	keep if beta_CF~=.
	cap drop year month
	gen year=int(date/100)
	gen month=date-100*year
	sort year month
	save "../output/betas_total_CV", replace
