 	clear
	gen x=.
	save "../output/betas_total_monthly", replace
	 
	
	insheet using "../source monthly/F-F_Research_Data_Factors.txt", names tab clear
	keep if date~=.
	keep mktrf rf date
	sort date
	save "../output/factors_monthly",replace     
	
	
			***************************************************************
			*********************construct CRSP samples******************
			***************************************************************

				
	use "../source/CRSP_monthly_79_14.dta", clear
	***cf cohen, polk and voltuehano
	replace ret=-.5 if ret<-.5
	replace ret=1 if ret>1&ret~=.
	gen date2=year(date)*100+month(date)
	ren date date3
	ren date2 date
	ren date3 date2
	sort date
	merge m:1 date using "../output/factors_monthly"
	drop if _m==2
	drop _m
	replace rf=rf/100
	gen ret_rf=ret-rf
	replace mktrf=mktrf/100
	keep permno ret_rf mktrf date date2
	sort date
	egen D=group(date)
	cap drop sigma2
	gen sigma2=.
	cap drop beta
	gen beta=.

	
	levelsof D, local(levels)
    foreach i of local levels{
	disp `i'
	preserve
	quietly keep if D>=`i'&D<`i'+24
	quietly cap drop x1
	quietly egen x1=mean(ret_rf) if mktrf~=.&ret_rf~=.,by(permno)
	quietly cap drop x2
	quietly egen x2=mean(mktrf) if mktrf~=.&ret_rf~=.,by(permno)
	quietly  cap drop xy
	quietly  gen xy=(ret_rf-x1)*(mktrf-x2) if ret_rf~=.&mktrf~=.
	quietly  cap drop X2
	quietly  gen X2=(mktrf-x2)^2 if ret_rf~=.&mktrf~=.
	quietly  cap drop S1
	quietly  egen S1=sum(xy),by(permno)
	quietly  cap drop S2
	quietly  egen S2=sum(X2),by(permno)
	quietly  cap drop N	
	quietly  egen N=count(xy),by(permno)
	quietly  replace beta=S1/S2 if D==`i'+23&N>=12
	quietly  cap drop temp
	quietly  gen temp=S1/S2 if N>12
	quietly  cap drop residual
	quietly  gen residual=(ret_rf-x1)-temp*(mktrf-x2) if ret_rf~=.&mktrf~=.
	quietly  cap drop temp
	quietly  egen temp=var(residual), by(permno)
	quietly  replace sigma2=temp if D==`i'+23&N>=12
	quietly  keep if D==`i'+23
	quietly  keep permno date date2 beta sigma2 N 
	quietly  append using "../output/betas_total_monthly"
	quietly  save "../output/betas_total_monthly", replace
	restore
	}


use "../output/betas_total_monthly", replace	
drop date
cap drop year
gen year=year(date2)
cap drop month
gen month=month(date2)
drop date2
gen date2=year*12+month
cap drop x
gen sigma=sqrt(sigma2)
drop sigma2
keep permno date2 sigma beta year month
ren beta beta_monthly
ren sigma sigma_monthly
sort permno date2
save "../output/betas_total_monthly", replace
