clear
clear mata
clear matrix
set mem 5g
set more 1

* input your directory here.
* cd 


****
***value-weighted CRSP monthly returns
use ../source/vw_index, clear
sort date
gen year=year(date)
gen month=month(date)
save ../output/temp,replace


use ../source/risk_free.dta, clear
ren mcaldt date
ren tmytm risk_free
keep date risk_free
replace risk_free=risk_free/100
gen x=(1+risk_free)^(1/12)-1
drop risk_free
ren x risk_free
gen year=year(date)
gen month=month(date)
sort year month
merge 1:1 year month using ../output/temp
keep if _m==3
drop _m

cap drop lrm_e
gen lrm_e=ln(1+vwret)-ln(1+risk_free)
sort year month
save ../output/temp,replace

insheet using ../source/yield_spread3.txt, names tab clear
gen year=real(substr(date,7,4))
gen month=real(substr(date,1,2))
gen yield_spread=yield_10-yield_3
drop date
sort year month
merge 1:1 year month using ../output/temp
keep if _m==3
drop _m
sort year month
save ../output/temp,replace


insheet using ../source/shiller.txt, names tab clear
sort date
egen D=group(date)
tsset D
gen E=.
quietly{
forvalues i=1(1)1730{
cap drop period
gen period=D>=`i'&D<=`i'+12*10-1
cap drop temp
egen temp=mean(e) if period==1
replace E=temp if D==`i'+12*10-1
}
}
gen lpe=ln(p/E)
gen year=int(date)
sort year date 
by year: gen month=_n
keep lpe year month
merge 1:1 year month using ../output/temp
keep if _m==3
drop _m
sort year month
save ../output/temp,replace

insheet using ../source/ret_smb_hml_vw.txt, names tab clear
ren v1 date
gen year = int(date/100)
sort year
save ../output/local, replace

insheet using ../source/be_me_vw2.txt, names tab clear
ren v1 year
sort year
merge 1:m year using ../output/local
keep if _m==3
drop _m
gen month=date-100*year
cap drop value_spread
gen value_spread=log(be_me_small_high)-log(be_me_small_low) if month==6
sort year month
egen D=group(year month)
tsset D
forvalues i=7(1)12{
replace value_spread=L.value_spread +log(1+ret_small_low/100)-log(1+ret_small_high/100) if month==`i'
}
forvalues i=1(1)5{
replace value_spread=L.value_spread +log(1+ret_small_low/100)-log(1+ret_small_high/100) if month==`i'
}

keep value_spread year month
merge 1:1 year month using ../output/temp
keep if _m==3
drop _m

cap drop D
egen D=group(year month)
tsset D
var lrm_e lpe yield_spread value_spread, lag(1)
predict u_r, res equation(#1)
predict u_lpe, res equation(#2)
predict u_ys, res equation(#3)
predict u_vs, res equation(#4)

cap  matrix drop a 
matrix a=e(b)
cap matrix drop  gamma
matrix gamma=(a[1,1],a[1,2],a[1,3],a[1,4]\a[1,6],a[1,7],a[1,8],a[1,9]\a[1,11],a[1,12],a[1,13],a[1,14]\a[1,16],a[1,17],a[1,18],a[1,19])
cap matrix drop temp1
mat temp1=(I(4)-.95*gamma)
cap matrix drop temp2
mat temp2=inv(temp1)
cap matrix drop lambda
mat lambda=.95*gamma*temp2
cap matrix drop e1
mat e1=(1,0,0,0)
cap matrix drop temp3
mat temp3=e1*lambda

gen DR=temp3[1,1]*u_r+temp3[1,2]*u_lpe+temp3[1,3]*u_ys+temp3[1,4]*u_vs

cap matrix drop temp4
mat temp4=e1+temp3
gen CF=temp4[1,1]*u_r+temp4[1,2]*u_lpe+temp4[1,3]*u_ys+temp4[1,4]*u_vs
ren CF ncf
ren DR nr

cap drop D
egen D=group(year month)
tsset D
gen ncf_1=L.ncf
gen nr_1=L.nr
keep year month ncf* nr*
sort year month
save ../output/news, replace
