dclear
clear mata
clear matrix
set mem 5g
set more 1

* input your directory here.
* cd 

	use  "../output/monthly_factor"
	keep dateff smb hml umd mkt*
	ren dateff date
	gen year=year(date)
	gen month=month(date)
	drop date
	****merge with aggregate disagreement measure computed above
	gen date2=year*12+month
	sort date2
	merge m:1 date2 using  "../output/aggregate_disp"
	drop if _m==2
	drop _m	
	sort year month
	save  "../output/temp", replace
	****merge with d, p and e of aggregate stock market from shiller	
	insheet using "../source/shiller.txt", names tab clear
	gen dp=d/p
	replace dp=dp*100
	gen pe=p/e
	gen year=int(date)
	sort year date 
	by year: gen month=_n
	drop date 
	keep dp pe year month
	sort year month
	merge 1:m year month using "../output/temp"
	drop if _m==1
	drop _m
	sort year month
	save "../output/temp", replace	
	
	* merge with TED SPREAD data from Global financial data
	insheet using "../source/ted2.txt", names tab clear
	gen year=real(substr(date,7,4))
	gen month=real(substr(date,1,2))
	keep year month ted
	rename ted TED
	sort year month
	merge 1:m year month using "../output/temp"
	drop if _m==1
	drop _m
	sort year month

	save "../output/temp", replace	

	****merge with inflation rate
	insheet using "../source/inflation.txt", names tab clear
	gen year=real(substr(date,1,4))
	gen month=real(substr(date,6,2))	
	keep inflation year month
	destring inflation, force replace
	sort year month
	merge 1:m year month using "../output/temp"
	drop if _m==1
	drop _m
	sort year month
	save "../output/temp", replace	
	
	****merge with topdown_disagreement
	use "../source/topdown_disag", replace
	sort year month
	merge 1:1 year month using  "../source/topdown_disag_oper_EPS"
	drop _m
	gen date=year*12+month
	tsset date
	keep topdown* year month
	egen m=mean(topdown_disag1)
 	egen s=sd(topdown_disag1)
 	replace topdown_disag1=(topdown_disag1-m)/s
 	drop m s
	egen m=mean(topdown_disag2)
 	egen s=sd(topdown_disag2)
 	replace topdown_disag2=(topdown_disag2-m)/s
 	drop m s
	sort year month	
	merge 1:m year month using "../output/temp"
	drop if _m==1
	drop _m
	sort year month
	save "../output/temp", replace	


	use "../source/disag_series", replace
	sort year month
	egen m=mean(spf)
 	egen s=sd(spf)
 	replace spf=(spf-m)/s
 	drop m s
	sort year month	
	merge 1:m year month using "../output/temp"
	drop if _m==1
	drop _m 
	sort year month
	egen D=group(year month)
	tsset D
	foreach y in mktrf hml smb umd{
		gen `y'_1=(F1.`y')*100
		gen `y'_3=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')-1)*100
		gen `y'_6=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')-1)*100
		gen `y'_9=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')-1)*100
		gen `y'_12=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')*(1+F10.`y')*(1+F11.`y')*(1+F12.`y')-1)*100
		gen `y'_18=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')*(1+F10.`y')*(1+F11.`y')*(1+F12.`y')*(1+F13.`y')*(1+F14.`y')*(1+F15.`y')*(1+F16.`y')*(1+F17.`y')*(1+F18.`y')-1)*100
				}

	drop date2 D
	sort year month
	save "../output/temp", replace
	*** profitability factor from Novy-Marx
	insheet using ../source/pmu.txt, names tab clear
	gen year=int(date/100)
	gen month=date-100*year
	drop date
	
	egen D=group(year month)
	tsset D
	foreach y in pmu{
		gen `y'_1=(F1.`y')*100
		gen `y'_3=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')-1)*100
		gen `y'_6=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')-1)*100
		gen `y'_9=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')-1)*100
		gen `y'_12=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')*(1+F10.`y')*(1+F11.`y')*(1+F12.`y')-1)*100
		gen `y'_18=((1+F1.`y')*(1+F2.`y')*(1+F3.`y')*(1+F4.`y')*(1+F5.`y')*(1+F6.`y')*(1+F7.`y')*(1+F8.`y')*(1+F9.`y')*(1+F10.`y')*(1+F11.`y')*(1+F12.`y')*(1+F13.`y')*(1+F14.`y')*(1+F15.`y')*(1+F16.`y')*(1+F17.`y')*(1+F18.`y')-1)*100
				}
				
	drop D
	sort year month
	merge 1:1 year month using ../output/temp
	drop if _m==1
	drop _m
	sort year month
	save "../output/time_series", replace
	
